# mypy-boto3-codepipeline

[![PyPI - mypy-boto3-codepipeline](https://img.shields.io/pypi/v/mypy-boto3-codepipeline.svg?color=blue)](https://pypi.org/project/mypy-boto3-codepipeline)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-codepipeline.svg?color=blue)](https://pypi.org/project/mypy-boto3-codepipeline)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.CodePipeline 1.12.32](https://boto3.amazonaws.com/v1/documentation/api/1.12.32/reference/services/codepipeline.html#CodePipeline) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 1.0.6](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-codepipeline](#mypy-boto3-codepipeline)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

### Type checking

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `CodePipeline` service.

```bash
python -m pip install boto3-stubs[mypy-boto3-codepipeline]
```

Use `boto3` with `mypy_boto3` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3 import codepipeline
# alternative import if you do not want to install mypy_boto3 package
# import mypy_boto3_codepipeline as codepipeline

# Use this client as usual, now mypy can check if your code is valid.
# Check if your IDE supports function overloads,
# you probably do not need explicit type annotations
# client = boto3.client("codepipeline")
client: codepipeline.CodePipelineClient = boto3.client("codepipeline")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: codepipeline.CodePipelineClient = session.client("codepipeline")


# Paginators need type annotation on creation
list_action_executions_paginator: codepipeline.ListActionExecutionsPaginator = client.get_paginator("list_action_executions")
list_action_types_paginator: codepipeline.ListActionTypesPaginator = client.get_paginator("list_action_types")
list_pipeline_executions_paginator: codepipeline.ListPipelineExecutionsPaginator = client.get_paginator("list_pipeline_executions")
list_pipelines_paginator: codepipeline.ListPipelinesPaginator = client.get_paginator("list_pipelines")
list_tags_for_resource_paginator: codepipeline.ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
list_webhooks_paginator: codepipeline.ListWebhooksPaginator = client.get_paginator("list_webhooks")
```

## How it works

Fully automated [builder](https://github.com/vemel/mypy_boto3_builder) carefully generates
type annotations for each service, patiently waiting for `boto3` updates. It delivers
a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type annotations
  extracted from the documentation (blame `botocore` docs if types are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) for readability.